unit ReadBarcode;

interface

uses
    SysUtils;

type
    TBarcodeData = array of Byte;

function ReadCode39(const Data: array of Byte; var Text: string; var Err: string): Boolean;
function ReadJan(const Data: array of Byte; var Text: string; var Err: string): Boolean;

implementation

//-----------------------------------------------------------------------------
//  獕܂ł؂o
function TrimBtoB(const Data: array of Byte; var Dest: TBarcodeData; var Err: string): Boolean;
var
    First1Pos, Last1Pos: integer;
begin
    Result := False;

    //-------------------------------------------
    //  f[^ʒu
    First1Pos := 0;

    //  1oʒu
    while (First1Pos < Length(Data)) and (Data[First1Pos] = 0) do Inc(First1Pos);

    //  ŌɓBĂI
    if (First1Pos >= Length(Data)) then
    begin
        Err := 'o[R[hf[^ł͂܂B';
        Exit;
    end;

    //-------------------------------------------
    //  f[^ʒu
    Last1Pos := Length(Data) - 1;

    //  X1oʒu
    while (0 <= Last1Pos) and (Data[Last1Pos] = 0) do Dec(Last1Pos);

    //  ܂łĂƂƂ͈1̂őv

    //-------------------------------------------
    //  1oO0ƃX1o0̂ĂăRs[
    SetLength(Dest, Last1Pos - First1Pos + 1);
    Move(Data[First1Pos], Dest[0], SizeOf(Byte) * Length(Dest));

    Result := True;
end;

//-----------------------------------------------------------------------------
//  1,0ȂzA1,0ꂼ̘Ao񐔂̔zɒ (Ex) 1111000110=>4321
function SumCount(const Buf: TBarcodeData; var SumBuf: TBarcodeData): integer;
var
    i: integer;
    Prev, Curr, Counter: integer;
begin
    //  1Ԗڂ̒loĂ
    Prev := Buf[0];

    //  1ɂĂ
    Counter := 1;

    //  ʔz̒
    Result := 0;

    //  2Ԗڈȍ~ɒׂĂ
    for i := 1 to Length(Buf) - 1 do
    begin
        //  ̒l
        Curr := Buf[i];

        //  O̒lƓ
        if (Prev = Curr) then
        begin
            Inc(Counter);
        end
        //  قȂ
        else
        begin
            //  zɓ˂
            Inc(Result);
            SetLength(SumBuf, Result);
            SumBuf[Result - 1] := Counter;

            //  JE^NA
            Counter := 1;
        end;

        //  O̒lXV
        Prev := Curr;        
    end;

    //  Ōɂx
    Inc(Result);
    SetLength(SumBuf, Result);
    SumBuf[Result - 1] := Counter;
end;

//-----------------------------------------------------------------------------
//  CODE-39ǂ
function ReadCode39(const Data: array of Byte; var Text: string; var Err: string): Boolean;
var
    Buf, SumBuf: TBarcodeData;
    i, Temp, SumBufLen, CharLen: integer;
    WideVal, NaroVal: integer;
    CharBuf: array of integer;
begin
    Result := False;

    //-------------------------------------------
    //  1oO0ƃX1o0̂ĂăRs[
    if not TrimBtoB(Data, Buf, Err) then Exit;

    //-------------------------------------------
    //  0/1z0/1̘Aozɕϊ
    SumBufLen := SumCount(Buf, SumBuf);

    //-------------------------------------------
    //  STEP3

    //  TCY`FbN(1ł 9+1+[9]+1+9)
    if ((SumBufLen + 1) mod 10 <> 0) then
    begin
        Err := 'CODE39ł͂ȂłBo[ƃXy[XƃMbv̐܂B';
        Exit;
    end;

    //  𐔂
    CharLen := (SumBufLen + 1) div 10;

    //  ͂Ȃ
    if (CharLen < 3) then
    begin
        Err := 'CODE39ł͂ȂłBȂƂ3ȏɂȂ͂łB';
        Exit;
    end;

    //-------------------------------------------
    //  STEP4

    //  ̑/1/0ɒuBzƂẮASumBuf[0]lASumBuf[1]
    //  傫lŁA2ނ̐gpĂȂƊAȂ
    //  ȂB͏2{3{x̂͂B
    NaroVal := SumBuf[0];
    WideVal := SumBuf[1];

    //  TCY`FbN
    if (WideVal * 10 < NaroVal * 2 * {10}8) then
    begin
        Err := 'אɔׂď[ȑ܂B';
        Exit;
    end
    else if (WideVal * {10}8 > NaroVal * 3 * 10) then
    begin
        Err := 'אɔׂđ悤łB';
        Exit;
    end;

    for i := 0 to SumBufLen - 1 do
    begin
        //  LN^ԃMbv͖
        if ((i + 1) mod 10 = 0) then continue;

        //  lƂ̍אȉ
        if (Abs(WideVal - SumBuf[i]) * 2 < NaroVal) then
        begin
            //  Ȃ͑łB
            SumBuf[i] := 1;
        end
        //  lƂ̍
        else if (Abs(NaroVal - SumBuf[i]) * 2 < NaroVal) then
        begin
            //  Ȃ͍אłB
            SumBuf[i] := 0;
        end
        //  ̑
        else
        begin
            Err := 'א̃oXłB';
            Exit;
        end;
    end;

    //-------------------------------------------
    //  STEP5

    //  (9)ɋ؂Ă

    //  ̃o[R[ȟ킷Buf̃TCYύX
    SetLength(CharBuf, CharLen);

    for i := 0 to CharLen - 1 do
    begin
        Temp := 10 * i;
        CharBuf[i] := SumBuf[Temp + 0] * 256
                    + SumBuf[Temp + 1] * 128
                    + SumBuf[Temp + 2] * 64
                    + SumBuf[Temp + 3] * 32
                    + SumBuf[Temp + 4] * 16
                    + SumBuf[Temp + 5] * 8
                    + SumBuf[Temp + 6] * 4
                    + SumBuf[Temp + 7] * 2
                    + SumBuf[Temp + 8] * 1;
        //SumBuf[Temp + 9] LN^ԃMbv
    end;

    //-------------------------------------------
    //  STEP6

    //  o
    Text := '';
    for i := 0 to CharLen - 1 do
    begin
        case CharBuf[i] of
        289: Text := Text + '1';
         97: Text := Text + '2';
        352: Text := Text + '3';
         49: Text := Text + '4';
        304: Text := Text + '5';
        112: Text := Text + '6';
         37: Text := Text + '7';
        292: Text := Text + '8';
        100: Text := Text + '9';
         52: Text := Text + '0';
        265: Text := Text + 'A';
         73: Text := Text + 'B';
        328: Text := Text + 'C';
         25: Text := Text + 'D';
        280: Text := Text + 'E';
         88: Text := Text + 'F';
         13: Text := Text + 'G';
        268: Text := Text + 'H';
         76: Text := Text + 'I';
         28: Text := Text + 'J';
        259: Text := Text + 'K';
         67: Text := Text + 'L';
        322: Text := Text + 'M';
         19: Text := Text + 'N';
        274: Text := Text + 'O';
         82: Text := Text + 'P';
          7: Text := Text + 'Q';
        262: Text := Text + 'R';
         70: Text := Text + 'S';
         22: Text := Text + 'T';
        385: Text := Text + 'U';
        193: Text := Text + 'V';
        448: Text := Text + 'W';
        145: Text := Text + 'X';
        400: Text := Text + 'Y';
        208: Text := Text + 'Z';
        133: Text := Text + '-';
        388: Text := Text + '.';
        196: Text := Text + ' ';
        148: Text := Text + '*';
        168: Text := Text + '$';
        162: Text := Text + '/';
        138: Text := Text + '+';
         42: Text := Text + '%';
        else Text := Text + '?';
        end;
    end;

    //-------------------------------------------
    //  STEP7

    //  X^[gR[hEXgbvR[h`FbN
    if (Text[1] <> '*') then
    begin
        Err := 'X^[gR[h*ł͂܂B' + Text;
        Exit;
    end
    else if (Text[Length(Text)] <> '*') then
    begin
        Err := 'XgbvR[h*ł͂܂B' + Text;
        Exit;
    end;

    //  X^[gR[hEXgbvR[h
    Delete(Text, 1, 1);
    Delete(Text, Length(Text), 1);

    Result := True;
end;

//-----------------------------------------------------------------------------
//  vtBbNXLN^
function GetJanPrefixChar(const ParityBuf: array of integer): Char;
const
    PARITY_BUF: array['0'..'9'] of array[0..5] of integer =
    (
        (0,0,0,0,0,0),
        (0,0,1,0,1,1),
        (0,0,1,1,0,1),
        (0,0,1,1,1,0),
        (0,1,0,0,1,1),
        (0,1,1,0,0,1),
        (0,1,1,1,0,0),
        (0,1,0,1,0,1),
        (0,1,0,1,1,0),
        (0,1,1,0,1,0)
    );
var
    c: Char;
begin
    Result := #0;
    for c := Low(PARITY_BUF) to High(PARITY_BUF) do
    begin
        if CompareMem(@ParityBuf, @PARITY_BUF[c], SizeOf(ParityBuf)) then
        begin
            Result := c;
            Break;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  JANǂ
function ReadJan(const Data: array of Byte; var Text: string; var Err: string): Boolean;
var
    Buf, SumBuf: TBarcodeData;
    i, Offset, SumBufLen, CharLen: integer;
    CharBuf: array of integer;
    ParityBuf: array[0..5] of integer;
    c: Char;
begin
    Result := False;

    //-------------------------------------------
    //  1oO0ƃX1o0̂ĂăRs[
    if not TrimBtoB(Data, Buf, Err) then Exit;

    //-------------------------------------------
    //  0/1z0/1̘Aozɕϊ
    SumBufLen := SumCount(Buf, SumBuf);

    //-------------------------------------------
    //  tgK[ho[        101                     3
    //  f[^L          **** (*=1..4)   6   24
    //  Z^[o[            01010                   5
    //  Ef[^L          **** (*=1..4)   5   20
    //  W`FbNL  **** (*=1..4)   1   4
    //  CgK[ho[        101                     3
    //  SumBuf̔z񒷂́A59̂͂
    if (SumBufLen <> 59) then
    begin
        Err := 'JANł͂܂B';
        Exit;
    end;

    //-------------------------------------------
    //  Pʂ̑ɒ(tɂĂ͍̂ŏSumBuf[0]SumBuf[0]
    //  ZĂ܂Ǝc̗vf邱ƂłȂ)
    for i := SumBufLen - 1 downto 0 do
    begin
        SumBuf[i] := SumBuf[i] div SumBuf[0];
    end;

    //-------------------------------------------
    //  Ƃɋ؂Ă
    CharLen := 15;
    SetLength(CharBuf, CharLen);

    Offset := 0;

    //  tgK[go[
    CharBuf[0] := SumBuf[Offset + 0] * 100
                + SumBuf[Offset + 1] * 10
                + SumBuf[Offset + 2] * 1;
    Inc(Offset, 3);

    //  f[^LN^(6)
    for i := 1 to 6 do
    begin
        CharBuf[i] := SumBuf[Offset + 0] * 1000
                    + SumBuf[Offset + 1] * 100
                    + SumBuf[Offset + 2] * 10
                    + SumBuf[Offset + 3] * 1;
        Inc(Offset, 4);
    end;

    //  Z^[o[
    CharBuf[7] := SumBuf[Offset + 0] * 10000
                + SumBuf[Offset + 1] * 1000
                + SumBuf[Offset + 2] * 100
                + SumBuf[Offset + 3] * 10
                + SumBuf[Offset + 4] * 1;
    Inc(Offset, 5);

    //  Ef[^LN^ƃW`FbNLN^(킹6)
    for i := 8 to 13 do
    begin
        CharBuf[i] := SumBuf[Offset + 0] * 1000
                    + SumBuf[Offset + 1] * 100
                    + SumBuf[Offset + 2] * 10
                    + SumBuf[Offset + 3] * 1;
        Inc(Offset, 4);
    end;

    //  CgK[ho[
    CharBuf[14] := SumBuf[Offset + 0] * 100
                 + SumBuf[Offset + 1] * 10
                 + SumBuf[Offset + 2] * 1;

    //-------------------------------------------
    //  ۂ̕ɕϊ
    Text := '';

    //  tgK[go[
    if (CharBuf[0] <> 111) then
    begin
        Err := 'tgK[ho[ɖ肠B';
        Exit;
    end;

    //  f[^LN^
    for i := 1 to 6 do
    begin
        case CharBuf[i] of
        //  0
        3211,
        1123: Text := Text + '0';
        //  1
        2221,
        1222: Text := Text + '1';
        //  2
        2122,
        2212: Text := Text + '2';
        //  3
        1411,
        1141: Text := Text + '3';
        //  4
        1132,
        2311: Text := Text + '4';
        //  5
        1231,
        1321: Text := Text + '5';
        //  6
        1114,
        4111: Text := Text + '6';
        //  7
        1312,
        2131: Text := Text + '7';
        //  8
        1213,
        3121: Text := Text + '8';
        //  9
        3112,
        2113: Text := Text + '9';
        end;
    end;

    //  ̃peB
    for i := 1 to 6 do
    begin
        case CharBuf[i] of
        //  peB
        3211, 2221, 2122, 1411, 1132, 1231, 1114, 1312, 1213, 3112:
            ParityBuf[i - 1] := 0;

        //  peB
        1123, 1222, 2212, 1141, 2311, 1321, 4111, 2131, 3121, 2113:
            ParityBuf[i - 1] := 1;

        //  ̑
        else
            ParityBuf[i - 1] := 2;
        end;
    end;

    //  vtBbNXLN^m
    c := GetJanPrefixChar(ParityBuf);
    if (c = #0) then
    begin
        Err := 'vtBbNXLN^擾ł';
        Exit;
    end;

    Text := c + Text;

    //  Z^[o[
    if (CharBuf[7] <> 11111) then
    begin
        Err := 'Z^[o[ɖ肠B';
        Exit;
    end;

    //  Ef[^LN^
    for i := 8 to 13 do
    begin
        case CharBuf[i] of
        //  0
        3211: Text := Text + '0';
        //  1
        2221: Text := Text + '1';
        //  2
        2122: Text := Text + '2';
        //  3
        1411: Text := Text + '3';
        //  4
        1132: Text := Text + '4';
        //  5
        1231: Text := Text + '5';
        //  6
        1114: Text := Text + '6';
        //  7
        1312: Text := Text + '7';
        //  8
        1213: Text := Text + '8';
        //  9
        3112: Text := Text + '9';
        end;
    end;

    //  CgK[go[
    if (CharBuf[14] <> 111) then
    begin
        Err := 'CgK[ho[ɖ肠B';
        Exit;
    end;

    Result := True;
end;

end.
