unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Image1: TImage;
    PaintBox1: TPaintBox;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BitBtn2Click(Sender: TObject);
  private
    Bmp: TBitmap;
    Bits: array of Byte;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    ClipBrd,
    ReadBarcode;

//-----------------------------------------------------------------------------
//  FormCreate
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  _uobt@p̃rbg}bv쐬
    Bmp := TBitmap.Create;
    //  ScanLineg߂24bitɂĂ
    Bmp.PixelFormat := pf24bit;
    //  ̂ŃtHg𒲐
    Bmp.Canvas.Font.Assign(Self.Font);

    //  h~
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
end;

//-----------------------------------------------------------------------------
//  FormDestroy
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  _uobt@p̃rbg}bvj
    Bmp.Free;
end;

//-----------------------------------------------------------------------------
//  Nbv{[hɓĂ͂̃o[R[h\t
procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
    //  .bmpȂ
    if (Clipboard.HasFormat(CF_BITMAP)) then
    begin
        //  BImageɓ\t
        Image1.Picture.LoadFromClipboardFormat(cf_BitMap, ClipBoard.GetAsHandle(cf_Bitmap), 0);
        //  \XV
        PaintBox1.Repaint;
    end;
end;

//-----------------------------------------------------------------------------
//  t@Cǂݍ
procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
    if OpenDialog1.Execute then
    begin
        //  BImageɓ\t
        Image1.Picture.LoadFromFile(OpenDialog1.FileName);
        //  \XV
        PaintBox1.Repaint;
    end;
end;

//-----------------------------------------------------------------------------
//  IntegerByteɉ
function Set255(Value: Integer): Byte;
begin
    if Value >= 255 then Result := 255
    else if Value <= 0 then Result := 0
    else Result := Value;
end;

//-----------------------------------------------------------------------------
//  `
procedure TMainForm.PaintBox1Paint(Sender: TObject);
const
    BIT_: array[Boolean] of Byte = (0, 1);
var
    Pbox: TPaintBox;
    Pt: TPoint;
    Line: PByteArray;
    R, G, B, Gray: Byte;
    i: integer;
    Item, Err: string;
    DrawFormat: Cardinal;
    Rect: TRect;
begin
    //  LXgĂ
    Pbox := TPaintBox(Sender);

    //  _uobt@̃TCY
    Bmp.Width := Pbox.Width;
    Bmp.Height := Pbox.Height;

    //  ܂ɓhԂ
    Bmp.Canvas.Brush.Color := clWhite;
    Bmp.Canvas.FillRect(Pbox.ClientRect);

    //  BImageɓǂݍ񂾉摜`
    Bmp.Canvas.Draw(0, 0, Image1.Picture.Bitmap);

    //  }EXJ[\ʒu擾
    GetCursorPos(Pt);
    Pt := Pbox.ScreenToClient(Pt);

    //  }EXJ[\ɉA̐̍lzɒ@
    if (0 <= Pt.Y) and (Pt.Y < Bmp.Height) then
    begin
        //  zĂ
        SetLength(Bits, Bmp.Width);

        //  1Co
        Line := Bmp.ScanLine[Pt.Y];

        //  z̕rbg}bv̕ƂȂ悤ɂƂ(TCYύXs)
        for i := 0 to Bmp.Width{400} - 1 do
        begin
            //  RGBlꂼo
            R := Line[i * 3 + 2];
            G := Line[i * 3 + 1];
            B := Line[i * 3 + 0];
            //  NTSCndϖ@păO[XP[
            Gray := Set255((Round(R * 0.289 + G * 0.586 + B * 0.114)));
            //Gray := Set255((R + G + B) div 3);

            //  ^łԂ؂Ĕ2l
            Bits[i] := BIT_[Gray < 127];
        end;

        //  JAN
        if RadioButton2.Checked then
        begin
            if not ReadJan(Bits, Item, Err) then
            begin
                Item := Err;
            end;
        end
        //  CODE39
        else
        begin
            if not ReadCode39(Bits, Item, Err) then
            begin
                Item := Err;
            end;
        end;

        //  `Ă݂
        DrawFormat := DT_LEFT or DT_BOTTOM or DT_NOCLIP or DT_SINGLELINE;
        Rect := Pbox.ClientRect;
        DrawTextEx(Bmp.Canvas.Handle, PChar(Item), -1, Rect, DrawFormat, nil);
    end;

    //  `
    Bmp.Canvas.Pen.Color := clRed;
    Bmp.Canvas.MoveTo(Pbox.Left, Pt.Y);
    Bmp.Canvas.LineTo(Pbox.Left + Pbox.Width, Pt.Y);

    //  ʕ\
    BitBlt(Pbox.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height,
            Bmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
//  }EXтɉ
procedure TMainForm.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
    TPaintBox(Sender).Repaint;
end;

end.
